Index: /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/BDY/bdydta.F90
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/BDY/bdydta.F90	(revision 4291)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/BDY/bdydta.F90	(revision 4292)
@@ -486,45 +588,60 @@
                   ilen1(jfld) = nblen(igrid(jfld))
                   ilen3(jfld) = 1
-               ENDIF
-
-            ENDIF
-
-            ! baroclinic velocities
-            IF( ( nn_dyn3d(ib_bdy) .gt. 0 .and. nn_dyn3d_dta(ib_bdy) .eq. 1 ) .or. &
-           &      ( ln_full_vel_array(ib_bdy) .and. nn_dyn2d(ib_bdy) .gt. 0 .and.  &
-           &        ( nn_dyn2d_dta(ib_bdy) .eq. 1 .or. nn_dyn2d_dta(ib_bdy) .eq. 3 ) ) ) THEN
-
-               jfld = jfld + 1
-               blf_i(jfld) = bn_u3d
-               ibdy(jfld) = ib_bdy
-               igrid(jfld) = 2
-               ilen1(jfld) = nblen(igrid(jfld))
-               ilen3(jfld) = jpk
-
-               jfld = jfld + 1
-               blf_i(jfld) = bn_v3d
-               ibdy(jfld) = ib_bdy
-               igrid(jfld) = 3
-               ilen1(jfld) = nblen(igrid(jfld))
-               ilen3(jfld) = jpk
+                  dta%nread(2) = dta%nread(2) + 1
+               ENDIF
+
+            ENDIF
+
+            ! read 3D velocities if baroclinic velocities require OR if
+            ! barotropic velocities required and ln_full_vel set to .true.
+            IF( nn_dyn3d_dta(ib_bdy) .eq. 1 .or. &
+           &  ( ln_full_vel_array(ib_bdy) .and. ( nn_dyn2d_dta(ib_bdy) .eq. 1 .or. nn_dyn2d_dta(ib_bdy) .eq. 3 ) ) ) THEN
+
+               IF( dta%ll_u3d .or. ( ln_full_vel_array(ib_bdy) .and. dta%ll_u2d ) ) THEN
+                  if(lwp) write(numout,*) '++++++ reading in u3d field'
+                  jfld = jfld + 1
+                  blf_i(jfld) = bn_u3d
+                  ibdy(jfld) = ib_bdy
+                  igrid(jfld) = 2
+                  ilen1(jfld) = nblen(igrid(jfld))
+                  ilen3(jfld) = jpk
+                  IF( ln_full_vel_array(ib_bdy) .and. dta%ll_u2d ) dta%nread(2) = dta%nread(2) + 1
+               ENDIF
+
+               IF( dta%ll_v3d .or. ( ln_full_vel_array(ib_bdy) .and. dta%ll_v2d ) ) THEN
+                  if(lwp) write(numout,*) '++++++ reading in v3d field'
+                  jfld = jfld + 1
+                  blf_i(jfld) = bn_v3d
+                  ibdy(jfld) = ib_bdy
+                  igrid(jfld) = 3
+                  ilen1(jfld) = nblen(igrid(jfld))
+                  ilen3(jfld) = jpk
+                  IF( ln_full_vel_array(ib_bdy) .and. dta%ll_v2d ) dta%nread(2) = dta%nread(2) + 1
+               ENDIF
 
             ENDIF
 
             ! temperature and salinity
-            IF( nn_tra(ib_bdy) .gt. 0 .and. nn_tra_dta(ib_bdy) .eq. 1 ) THEN
-
-               jfld = jfld + 1
-               blf_i(jfld) = bn_tem
-               ibdy(jfld) = ib_bdy
-               igrid(jfld) = 1
-               ilen1(jfld) = nblen(igrid(jfld))
-               ilen3(jfld) = jpk
-
-               jfld = jfld + 1
-               blf_i(jfld) = bn_sal
-               ibdy(jfld) = ib_bdy
-               igrid(jfld) = 1
-               ilen1(jfld) = nblen(igrid(jfld))
-               ilen3(jfld) = jpk
+            IF( nn_tra_dta(ib_bdy) .eq. 1 ) THEN
+
+               IF( dta%ll_tem ) THEN
+                  if(lwp) write(numout,*) '++++++ reading in tem field'
+                  jfld = jfld + 1
+                  blf_i(jfld) = bn_tem
+                  ibdy(jfld) = ib_bdy
+                  igrid(jfld) = 1
+                  ilen1(jfld) = nblen(igrid(jfld))
+                  ilen3(jfld) = jpk
+               ENDIF
+
+               IF( dta%ll_sal ) THEN
+                  if(lwp) write(numout,*) '++++++ reading in sal field'
+                  jfld = jfld + 1
+                  blf_i(jfld) = bn_sal
+                  ibdy(jfld) = ib_bdy
+                  igrid(jfld) = 1
+                  ilen1(jfld) = nblen(igrid(jfld))
+                  ilen3(jfld) = jpk
+               ENDIF
 
             ENDIF
@@ -532,28 +649,79 @@
 #if defined key_lim2
             ! sea ice
-            IF( nn_ice_lim2(ib_bdy) .gt. 0 .and. nn_ice_lim2_dta(ib_bdy) .eq. 1 ) THEN
-
-               jfld = jfld + 1
-               blf_i(jfld) = bn_frld
-               ibdy(jfld) = ib_bdy
-               igrid(jfld) = 1
-               ilen1(jfld) = nblen(igrid(jfld))
-               ilen3(jfld) = 1
-
-               jfld = jfld + 1
-               blf_i(jfld) = bn_hicif
-               ibdy(jfld) = ib_bdy
-               igrid(jfld) = 1
-               ilen1(jfld) = nblen(igrid(jfld))
-               ilen3(jfld) = 1
-
-               jfld = jfld + 1
-               blf_i(jfld) = bn_hsnif
-               ibdy(jfld) = ib_bdy
-               igrid(jfld) = 1
-               ilen1(jfld) = nblen(igrid(jfld))
-               ilen3(jfld) = 1
-
-            ENDIF
+            IF( nn_ice_lim2_dta(ib_bdy) .eq. 1 ) THEN
+
+               IF( dta%ll_frld ) THEN
+                  jfld = jfld + 1
+                  blf_i(jfld) = bn_frld
+                  ibdy(jfld) = ib_bdy
+                  igrid(jfld) = 1
+                  ilen1(jfld) = nblen(igrid(jfld))
+                  ilen3(jfld) = 1
+               ENDIF
+
+               IF( dta%ll_hicif ) THEN
+                  jfld = jfld + 1
+                  blf_i(jfld) = bn_hicif
+                  ibdy(jfld) = ib_bdy
+                  igrid(jfld) = 1
+                  ilen1(jfld) = nblen(igrid(jfld))
+                  ilen3(jfld) = 1
+               ENDIF
+
+               IF( dta%ll_hsnif ) THEN
+                  jfld = jfld + 1
+                  blf_i(jfld) = bn_hsnif
+                  ibdy(jfld) = ib_bdy
+                  igrid(jfld) = 1
+                  ilen1(jfld) = nblen(igrid(jfld))
+                  ilen3(jfld) = 1
+               ENDIF
+
+            ENDIF
+#elif defined key_lim3
+            ! sea ice
+            IF( nn_ice_lim_dta(ib_bdy) .eq. 1 ) THEN
+
+               ! Test for types of ice input (lim2 or lim3) 
+               CALL iom_open ( bn_a_i%clname, inum )
+               id1 = iom_varid ( inum, bn_a_i%clvar, kdimsz=zdimsz, kndims=zndims, ldstop = .FALSE. )
+               CALL iom_close ( inum )
+               !CALL fld_clopn ( bn_a_i, nyear, nmonth, nday, ldstop=.TRUE. )
+               !CALL iom_open ( bn_a_i %clname, inum )
+               !id1 = iom_varid ( bn_a_i%num, bn_a_i%clvar, kdimsz=zdimsz, kndims=zndims, ldstop = .FALSE. )
+      	       IF ( zndims == 4 ) THEN
+                 ll_bdylim3 = .TRUE.   ! lim3 input
+               ELSE
+                 ll_bdylim3 = .FALSE.  ! lim2 input      
+               ENDIF
+               ! End test
+
+               IF( dta%ll_a_i ) THEN
+                  jfld = jfld + 1
+                  blf_i(jfld) = bn_a_i
+                  ibdy(jfld) = ib_bdy
+                  igrid(jfld) = 1
+                  ilen1(jfld) = nblen(igrid(jfld))
+                  IF ( ll_bdylim3 ) THEN ; ilen3(jfld)=jpl ; ELSE ; ilen3(jfld)=1 ; ENDIF
+               ENDIF
+
+               IF( dta%ll_ht_i ) THEN
+                  jfld = jfld + 1
+                  blf_i(jfld) = bn_ht_i
+                  ibdy(jfld) = ib_bdy
+                  igrid(jfld) = 1
+                  ilen1(jfld) = nblen(igrid(jfld))
+                  IF ( ll_bdylim3 ) THEN ; ilen3(jfld)=jpl ; ELSE ; ilen3(jfld)=1 ; ENDIF
+               ENDIF
+
+               IF( dta%ll_ht_s ) THEN
+                  jfld = jfld + 1
+                   blf_i(jfld) = bn_ht_s
+                  ibdy(jfld) = ib_bdy
+                  igrid(jfld) = 1
+                  ilen1(jfld) = nblen(igrid(jfld))
+                  IF ( ll_bdylim3 ) THEN ; ilen3(jfld)=jpl ; ELSE ; ilen3(jfld)=1 ; ENDIF
+               ENDIF
+
 #endif
             ! Recalculate field counts
@@ -568,4 +736,6 @@
             ENDIF
 
+            dta%nread(1) = nb_bdy_fld(ib_bdy)
+
          ENDIF ! nn_dta .eq. 1
       ENDDO ! ib_bdy
@@ -596,51 +766,81 @@
 
          nblen => idx_bdy(ib_bdy)%nblen
-         nblenrim => idx_bdy(ib_bdy)%nblenrim
-
-         IF (nn_dyn2d(ib_bdy) .gt. 0) THEN
-            IF( nn_dyn2d_dta(ib_bdy) .eq. 0 .or. nn_dyn2d_dta(ib_bdy) .eq. 2 .or. ln_full_vel_array(ib_bdy) ) THEN
-               ilen0(1:3) = nblen(1:3)
-               ALLOCATE( dta_bdy(ib_bdy)%u2d(ilen0(2)) )
-               ALLOCATE( dta_bdy(ib_bdy)%v2d(ilen0(3)) )
-               IF ( nn_dyn2d(ib_bdy) .ne. jp_frs .and. (nn_dyn2d_dta(ib_bdy).eq.1.or.nn_dyn2d_dta(ib_bdy).eq.3) ) THEN
-                  jfld = jfld + 1
-                  dta_bdy(ib_bdy)%ssh => bf(jfld)%fnow(:,1,1)
+         dta => dta_bdy(ib_bdy)
+
+         if(lwp) then
+            write(numout,*) '++++++ dta%ll_ssh = ',dta%ll_ssh
+            write(numout,*) '++++++ dta%ll_u2d = ',dta%ll_u2d
+            write(numout,*) '++++++ dta%ll_v2d = ',dta%ll_v2d
+            write(numout,*) '++++++ dta%ll_u3d = ',dta%ll_u3d
+            write(numout,*) '++++++ dta%ll_v3d = ',dta%ll_v3d
+            write(numout,*) '++++++ dta%ll_tem = ',dta%ll_tem
+            write(numout,*) '++++++ dta%ll_sal = ',dta%ll_sal
+         endif
+
+         IF ( nn_dyn2d_dta(ib_bdy) .eq. 0 .or. nn_dyn2d_dta(ib_bdy) .eq. 2 ) THEN
+            if(lwp) write(numout,*) '++++++ dta%ssh/u2d/u3d allocated space'
+            IF( dta%ll_ssh ) ALLOCATE( dta%ssh(nblen(1)) )
+            IF( dta%ll_u2d ) ALLOCATE( dta%u2d(nblen(2)) )
+            IF( dta%ll_v2d ) ALLOCATE( dta%v2d(nblen(3)) )
+         ENDIF
+         IF ( nn_dyn2d_dta(ib_bdy) .eq. 1 .or. nn_dyn2d_dta(ib_bdy) .eq. 3 ) THEN
+            IF( dta%ll_ssh ) THEN
+               if(lwp) write(numout,*) '++++++ dta%ssh pointing to fnow'
+               jfld = jfld + 1
+               dta%ssh => bf(jfld)%fnow(:,1,1)
+            ENDIF
+            IF ( dta%ll_u2d ) THEN
+               IF ( ln_full_vel_array(ib_bdy) ) THEN
+                  if(lwp) write(numout,*) '++++++ dta%u2d allocated space'
+                  ALLOCATE( dta%u2d(nblen(2)) )
                ELSE
-                  ALLOCATE( dta_bdy(ib_bdy)%ssh(nblen(1)) )
-               ENDIF
-            ELSE
-               IF( nn_dyn2d(ib_bdy) .ne. jp_frs ) THEN
-                  jfld = jfld + 1
-                  dta_bdy(ib_bdy)%ssh => bf(jfld)%fnow(:,1,1)
-               ENDIF
+                  if(lwp) write(numout,*) '++++++ dta%u2d pointing to fnow'
+                  jfld = jfld + 1
+                  dta%u2d => bf(jfld)%fnow(:,1,1)
+               ENDIF
+            ENDIF
+            IF ( dta%ll_v2d ) THEN
+               IF ( ln_full_vel_array(ib_bdy) ) THEN
+                  if(lwp) write(numout,*) '++++++ dta%v2d allocated space'
+                  ALLOCATE( dta%v2d(nblen(3)) )
+               ELSE
+                  if(lwp) write(numout,*) '++++++ dta%v2d pointing to fnow'
+                  jfld = jfld + 1
+                  dta%v2d => bf(jfld)%fnow(:,1,1)
+               ENDIF
+            ENDIF
+         ENDIF
+
+         IF ( nn_dyn3d_dta(ib_bdy) .eq. 0 ) THEN
+            if(lwp) write(numout,*) '++++++ dta%u3d/v3d allocated space'
+            IF( dta%ll_u3d ) ALLOCATE( dta_bdy(ib_bdy)%u3d(nblen(2),jpk) )
+            IF( dta%ll_v3d ) ALLOCATE( dta_bdy(ib_bdy)%v3d(nblen(3),jpk) )
+         ENDIF
+         IF ( nn_dyn3d_dta(ib_bdy) .eq. 1 .or. &
+           &  ( ln_full_vel_array(ib_bdy) .and. ( nn_dyn2d_dta(ib_bdy) .eq. 1 .or. nn_dyn2d_dta(ib_bdy) .eq. 3 ) ) ) THEN
+            IF ( dta%ll_u3d .or. ( ln_full_vel_array(ib_bdy) .and. dta%ll_u2d ) ) THEN
+               if(lwp) write(numout,*) '++++++ dta%u3d pointing to fnow'
                jfld = jfld + 1
-               dta_bdy(ib_bdy)%u2d => bf(jfld)%fnow(:,1,1)
+               dta_bdy(ib_bdy)%u3d => bf(jfld)%fnow(:,1,:)
+            ENDIF
+            IF ( dta%ll_v3d .or. ( ln_full_vel_array(ib_bdy) .and. dta%ll_v2d ) ) THEN
+               if(lwp) write(numout,*) '++++++ dta%v3d pointing to fnow'
                jfld = jfld + 1
-               dta_bdy(ib_bdy)%v2d => bf(jfld)%fnow(:,1,1)
-            ENDIF
-         ENDIF
-
-         IF ( nn_dyn3d(ib_bdy) .gt. 0 .and. nn_dyn3d_dta(ib_bdy) .eq. 0 ) THEN
-            ilen0(1:3) = nblen(1:3)
-            ALLOCATE( dta_bdy(ib_bdy)%u3d(ilen0(2),jpk) )
-            ALLOCATE( dta_bdy(ib_bdy)%v3d(ilen0(3),jpk) )
-         ENDIF
-         IF ( ( nn_dyn3d(ib_bdy) .gt. 0 .and. nn_dyn3d_dta(ib_bdy) .eq. 1 ).or. &
-           &  ( ln_full_vel_array(ib_bdy) .and. nn_dyn2d(ib_bdy) .gt. 0 .and.   &
-           &    ( nn_dyn2d_dta(ib_bdy) .eq. 1 .or. nn_dyn2d_dta(ib_bdy) .eq. 3 ) ) ) THEN
-            jfld = jfld + 1
-            dta_bdy(ib_bdy)%u3d => bf(jfld)%fnow(:,1,:)
-            jfld = jfld + 1
-            dta_bdy(ib_bdy)%v3d => bf(jfld)%fnow(:,1,:)
-         ENDIF
-
-         IF (nn_tra(ib_bdy) .gt. 0) THEN
-            IF( nn_tra_dta(ib_bdy) .eq. 0 ) THEN
-               ilen0(1:3) = nblen(1:3)
-               ALLOCATE( dta_bdy(ib_bdy)%tem(ilen0(1),jpk) )
-               ALLOCATE( dta_bdy(ib_bdy)%sal(ilen0(1),jpk) )
-            ELSE
+               dta_bdy(ib_bdy)%v3d => bf(jfld)%fnow(:,1,:)
+            ENDIF
+         ENDIF
+
+         IF( nn_tra_dta(ib_bdy) .eq. 0 ) THEN
+            if(lwp) write(numout,*) '++++++ dta%tem/sal allocated space'
+            IF( dta%ll_tem ) ALLOCATE( dta_bdy(ib_bdy)%tem(nblen(1),jpk) )
+            IF( dta%ll_sal ) ALLOCATE( dta_bdy(ib_bdy)%sal(nblen(1),jpk) )
+         ELSE
+            IF( dta%ll_tem ) THEN
+               if(lwp) write(numout,*) '++++++ dta%tem pointing to fnow'
                jfld = jfld + 1
                dta_bdy(ib_bdy)%tem => bf(jfld)%fnow(:,1,:)
+            ENDIF
+            IF( dta%ll_sal ) THEN 
+               if(lwp) write(numout,*) '++++++ dta%sal pointing to fnow'
                jfld = jfld + 1
                dta_bdy(ib_bdy)%sal => bf(jfld)%fnow(:,1,:)
@@ -649,10 +849,9 @@
 
 #if defined key_lim2
-         IF (nn_ice_lim2(ib_bdy) .gt. 0) THEN
+         IF (nn_ice_lim(ib_bdy) .gt. 0) THEN
             IF( nn_ice_lim2_dta(ib_bdy) .eq. 0 ) THEN
-               ilen0(1:3) = nblen(1:3)
-               ALLOCATE( dta_bdy(ib_bdy)%frld(ilen0(1)) )
-               ALLOCATE( dta_bdy(ib_bdy)%hicif(ilen0(1)) )
-               ALLOCATE( dta_bdy(ib_bdy)%hsnif(ilen0(1)) )
+               ALLOCATE( dta_bdy(ib_bdy)%frld(nblen(1)) )
+               ALLOCATE( dta_bdy(ib_bdy)%hicif(nblen(1)) )
+               ALLOCATE( dta_bdy(ib_bdy)%hsnif(nblen(1)) )
             ELSE
                jfld = jfld + 1
@@ -662,4 +861,33 @@
                jfld = jfld + 1
                dta_bdy(ib_bdy)%hsnif => bf(jfld)%fnow(:,1,1)
+            ENDIF
+         ENDIF
+#elif defined key_lim3
+         IF (nn_ice_lim(ib_bdy) .gt. 0) THEN
+            IF( nn_ice_lim_dta(ib_bdy) .eq. 0 ) THEN
+               ALLOCATE( dta_bdy(ib_bdy)%a_i (nblen(1),jpl) )
+               ALLOCATE( dta_bdy(ib_bdy)%ht_i(nblen(1),jpl) )
+               ALLOCATE( dta_bdy(ib_bdy)%ht_s(nblen(1),jpl) )
+            ELSE
+               IF ( ll_bdylim3 ) THEN ! case input is lim3 type
+                  jfld = jfld + 1
+                  dta_bdy(ib_bdy)%a_i  => bf(jfld)%fnow(:,1,:)
+                  jfld = jfld + 1
+                  dta_bdy(ib_bdy)%ht_i => bf(jfld)%fnow(:,1,:)
+                  jfld = jfld + 1
+                  dta_bdy(ib_bdy)%ht_s => bf(jfld)%fnow(:,1,:)
+               ELSE ! case input is lim2 type
+                  jfld_ai  = jfld + 1
+                  jfld_hti = jfld + 2
+                  jfld_hts = jfld + 3
+                  jfld     = jfld + 3
+                  ALLOCATE( dta_bdy(ib_bdy)%a_i (nblen(1),jpl) )
+                  ALLOCATE( dta_bdy(ib_bdy)%ht_i(nblen(1),jpl) )
+                  ALLOCATE( dta_bdy(ib_bdy)%ht_s(nblen(1),jpl) )
+                  dta_bdy(ib_bdy)%a_i (:,:) = 0.0
+                  dta_bdy(ib_bdy)%ht_i(:,:) = 0.0
+                  dta_bdy(ib_bdy)%ht_s(:,:) = 0.0
+               ENDIF
+
             ENDIF
          ENDIF
Index: /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/BDY/bdydyn.F90
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/BDY/bdydyn.F90	(revision 4291)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/BDY/bdydyn.F90	(revision 4292)
@@ -30,5 +30,5 @@
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
    USE in_out_manager  !
-   USE domvvl          ! variable volume
+   USE domvvl
 
    IMPLICIT NONE
@@ -57,7 +57,8 @@
       LOGICAL, INTENT( in ), OPTIONAL :: dyn3d_only       ! T => only update baroclinic velocities
       !!
-      INTEGER               :: jk,ii,ij,ib,igrd     ! Loop counter
-      LOGICAL               :: ll_dyn2d, ll_dyn3d  
-      !!
+      INTEGER               :: jk,ii,ij,ib_bdy,ib,igrd     ! Loop counter
+      LOGICAL               :: ll_dyn2d, ll_dyn3d, ll_orlanski
+      !!
+      REAL(wp), POINTER, DIMENSION(:,:) :: phur1, phvr1     ! inverse depth at u and v points
 
       IF( nn_timing == 1 ) CALL timing_start('bdy_dyn')
@@ -70,4 +71,10 @@
       ENDIF
 
+      ll_orlanski = .false.
+      DO ib_bdy = 1, nb_bdy
+         IF ( cn_dyn2d(ib_bdy) == 'orlanski' .or. cn_dyn2d(ib_bdy) == 'orlanski_npo' &
+     &   .or. cn_dyn3d(ib_bdy) == 'orlanski' .or. cn_dyn3d(ib_bdy) == 'orlanski_npo') ll_orlanski = .true.
+      ENDDO
+
       !-------------------------------------------------------
       ! Set pointers
@@ -77,5 +84,6 @@
       phur => hur
       phvr => hvr
-      CALL wrk_alloc(jpi,jpj,pu2d,pv2d) 
+      CALL wrk_alloc(jpi,jpj,pua2d,pva2d) 
+      IF ( ll_orlanski ) CALL wrk_alloc(jpi,jpj,pub2d,pvb2d,phur1,phvr1) 
 
       !-------------------------------------------------------
@@ -83,25 +91,69 @@
       !-------------------------------------------------------
 
-      pu2d(:,:) = 0.e0
-      pv2d(:,:) = 0.e0
+      ! "After" velocities: 
+
+      pua2d(:,:) = 0.e0
+      pva2d(:,:) = 0.e0
+      
       IF (lk_vvl) THEN
-         DO jk = 1, jpkm1   !! Vertically integrated momentum trends
-            pu2d(:,:) = pu2d(:,:) + fse3u_a(:,:,jk) * umask(:,:,jk) * ua(:,:,jk)
-            pv2d(:,:) = pv2d(:,:) + fse3v_a(:,:,jk) * vmask(:,:,jk) * va(:,:,jk)
-         END DO
-         pu2d(:,:) = pu2d(:,:) / ( hu_0(:,:) + sshu_a(:,:) + 1._wp - umask(:,:,1) )
-         pv2d(:,:) = pv2d(:,:) / ( hv_0(:,:) + sshv_a(:,:) + 1._wp - vmask(:,:,1) )
+         phur1(:,:) = 0.
+         phvr1(:,:) = 0.
+         DO jk = 1, jpkm1
+            phur1(:,:) = phur1(:,:) + fse3u_a(:,:,jk) * umask(:,:,jk)
+            phvr1(:,:) = phvr1(:,:) + fse3v_a(:,:,jk) * vmask(:,:,jk)
+            pua2d(:,:) = pua2d(:,:) + fse3u_a(:,:,jk) * umask(:,:,jk) * ua(:,:,jk)
+            pva2d(:,:) = pva2d(:,:) + fse3v_a(:,:,jk) * vmask(:,:,jk) * va(:,:,jk)
+         END DO
+         phur1(:,:) = umask(:,:,1) / ( phur1(:,:) + 1. - umask(:,:,1) )
+         phvr1(:,:) = vmask(:,:,1) / ( phvr1(:,:) + 1. - vmask(:,:,1) )
+         pua2d(:,:) = pua2d(:,:) * phur1(:,:)
+         pva2d(:,:) = pva2d(:,:) * phvr1(:,:)
       ELSE
-         DO jk = 1, jpkm1   !! Vertically integrated momentum trends
-            pu2d(:,:) = pu2d(:,:) + fse3u(:,:,jk) * umask(:,:,jk) * ua(:,:,jk)
-            pv2d(:,:) = pv2d(:,:) + fse3v(:,:,jk) * vmask(:,:,jk) * va(:,:,jk)
-         END DO
-         pu2d(:,:) = pu2d(:,:) * phur(:,:)
-         pv2d(:,:) = pv2d(:,:) * phvr(:,:)
+         DO jk = 1, jpkm1
+            pua2d(:,:) = pua2d(:,:) + fse3u(:,:,jk) * umask(:,:,jk) * ua(:,:,jk)
+            pva2d(:,:) = pva2d(:,:) + fse3v(:,:,jk) * vmask(:,:,jk) * va(:,:,jk)
+         END DO
+         pua2d(:,:) = pua2d(:,:) * phur(:,:)
+         pva2d(:,:) = pva2d(:,:) * phvr(:,:)
       ENDIF
+
       DO jk = 1 , jpkm1
-         ua(:,:,jk) = ua(:,:,jk) - pu2d(:,:) * umask(:,:,jk)
-         va(:,:,jk) = va(:,:,jk) - pv2d(:,:) * vmask(:,:,jk)
+         ua(:,:,jk) = ua(:,:,jk) - pua2d(:,:)
+         va(:,:,jk) = va(:,:,jk) - pva2d(:,:)
       END DO
+
+      ! "Before" velocities (required for Orlanski condition): 
+
+      IF ( ll_orlanski ) THEN          
+         pub2d(:,:) = 0.e0
+         pvb2d(:,:) = 0.e0
+
+         IF (lk_vvl) THEN
+            phur1(:,:) = 0.
+            phvr1(:,:) = 0.
+            DO jk = 1, jpkm1   !! Vertically integrated momentum trends
+               phur1(:,:) = phur1(:,:) + fse3u_b(:,:,jk) * umask(:,:,jk)
+               phvr1(:,:) = phvr1(:,:) + fse3v_b(:,:,jk) * vmask(:,:,jk)
+               pub2d(:,:) = pub2d(:,:) + fse3u_b(:,:,jk) * umask(:,:,jk) * ub(:,:,jk)
+               pvb2d(:,:) = pvb2d(:,:) + fse3v_b(:,:,jk) * vmask(:,:,jk) * vb(:,:,jk)
+            END DO
+            phur1(:,:) = umask(:,:,1) / ( phur1(:,:) + 1. - umask(:,:,1) )
+            phvr1(:,:) = vmask(:,:,1) / ( phvr1(:,:) + 1. - vmask(:,:,1) )
+            pub2d(:,:) = pub2d(:,:) * phur1(:,:)
+            pvb2d(:,:) = pvb2d(:,:) * phvr1(:,:)
+         ELSE
+            DO jk = 1, jpkm1   !! Vertically integrated momentum trends
+               pub2d(:,:) = pub2d(:,:) + fse3u(:,:,jk) * umask(:,:,jk) * ub(:,:,jk)
+               pvb2d(:,:) = pvb2d(:,:) + fse3v(:,:,jk) * vmask(:,:,jk) * vb(:,:,jk)
+            END DO
+            pub2d(:,:) = pub2d(:,:) * phur(:,:)
+            pvb2d(:,:) = pvb2d(:,:) * phvr(:,:)
+         ENDIF
+
+         DO jk = 1 , jpkm1
+            ub(:,:,jk) = ub(:,:,jk) - pub2d(:,:)
+            vb(:,:,jk) = vb(:,:,jk) - pvb2d(:,:)
+         END DO
+      END IF
 
       !-------------------------------------------------------
@@ -119,9 +171,17 @@
 
       DO jk = 1 , jpkm1
-         ua(:,:,jk) = ( ua(:,:,jk) + pu2d(:,:) ) * umask(:,:,jk)
-         va(:,:,jk) = ( va(:,:,jk) + pv2d(:,:) ) * vmask(:,:,jk)
+         ua(:,:,jk) = ( ua(:,:,jk) + pua2d(:,:) ) * umask(:,:,jk)
+         va(:,:,jk) = ( va(:,:,jk) + pva2d(:,:) ) * vmask(:,:,jk)
       END DO
 
-      CALL wrk_dealloc(jpi,jpj,pu2d,pv2d) 
+      IF ( ll_orlanski ) THEN
+         DO jk = 1 , jpkm1
+            ub(:,:,jk) = ( ub(:,:,jk) + pub2d(:,:) ) * umask(:,:,jk)
+            vb(:,:,jk) = ( vb(:,:,jk) + pvb2d(:,:) ) * vmask(:,:,jk)
+         END DO
+      END IF
+
+      CALL wrk_dealloc(jpi,jpj,pua2d,pva2d) 
+      IF ( ll_orlanski ) CALL wrk_dealloc(jpi,jpj,pub2d,pvb2d) 
 
       IF( nn_timing == 1 ) CALL timing_stop('bdy_dyn')
